----------------------------------------------------------------------
-- Created by Actel CoreConsole - Thu Jan 04 10:38:02 2007
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

----------------------------------------------------------------------
-- Example entity declaration
----------------------------------------------------------------------

entity Example is
    -- Port list
    port(
        -- Inputs
        APBmslave0_PRDATA : in std_logic_vector(31 downto 0);
        NSYSRESET : in std_logic;
        RV_ICE_If_RV_TCK : in std_logic;
        RV_ICE_If_RV_TDI : in std_logic;
        RV_ICE_If_RV_TMS : in std_logic;
        RV_ICE_If_RV_nSRST_IN : in std_logic;
        RV_ICE_If_RV_nTRST : in std_logic;
        Remap : in std_logic;
        SYSCLK : in std_logic;
        UJTAG_UJTAG_TCK : in std_logic;
        UJTAG_UJTAG_TDI : in std_logic;
        UJTAG_UJTAG_TMS : in std_logic;
        UJTAG_UJTAG_TRSTB : in std_logic;
        -- Outputs
        APBmslave0_PADDR : out std_logic_vector(23 downto 0);
        APBmslave0_PENABLE : out std_logic;
        APBmslave0_PSELx : out std_logic;
        APBmslave0_PWDATA : out std_logic_vector(31 downto 0);
        APBmslave0_PWRITE : out std_logic;
        ExternalMemoryInterface_FlashCSN : out std_logic;
        ExternalMemoryInterface_FlashOEnN : out std_logic;
        ExternalMemoryInterface_FlashWEnN : out std_logic;
        ExternalMemoryInterface_MemAddr : out std_logic_vector(27 downto 0);
        ExternalMemoryInterface_MemReadN : out std_logic;
        ExternalMemoryInterface_MemWriteN : out std_logic;
        ExternalMemoryInterface_SramByteN : out std_logic_vector(3 downto 0);
        ExternalMemoryInterface_SramCSN : out std_logic;
        ExternalMemoryInterface_SramClk : out std_logic;
        ExternalMemoryInterface_SramOEnN : out std_logic;
        ExternalMemoryInterface_SramWEnN : out std_logic;
        HRESETN : out std_logic;
        RV_ICE_If_RV_RTCK : out std_logic;
        RV_ICE_If_RV_TDOUT : out std_logic;
        RV_ICE_If_RV_nTDOEN : out std_logic;
        UJTAG_UJTAG_TDO : out std_logic;
        -- Inouts
        ExternalMemoryInterface_MemData : inout std_logic_vector(31 downto 0)
    );
end Example;

----------------------------------------------------------------------
-- Example architecture body
----------------------------------------------------------------------

architecture RTL of Example is 

    --
    -- Component declarations
    --

    -- CoreAHB2APB
    component CoreAHB2APB
        -- Port list
        port(
            -- Inputs
            HADDR : in std_logic_vector(27 downto 0);
            HCLK : in std_logic;
            HREADY : in std_logic;
            HRESETn : in std_logic;
            HSEL : in std_logic;
            HTRANS : in std_logic_vector(1 downto 0);
            HWDATA : in std_logic_vector(31 downto 0);
            HWRITE : in std_logic;
            PRDATA : in std_logic_vector(31 downto 0);
            -- Outputs
            HRDATA : out std_logic_vector(31 downto 0);
            HREADYOUT : out std_logic;
            HRESP : out std_logic_vector(1 downto 0);
            PADDR : out std_logic_vector(23 downto 0);
            PENABLE : out std_logic;
            PSELECT : out std_logic_vector(15 downto 0);
            PWDATA : out std_logic_vector(31 downto 0);
            PWRITE : out std_logic
        );
    end component;

    -- CoreAHBLite
    component CoreAHBLite
        -- Configuration generics
        generic(
            AhbSlot0Enable : integer := 1;
            AhbSlot10Enable : integer := 0;
            AhbSlot11Enable : integer := 0;
            AhbSlot12Enable : integer := 0;
            AhbSlot13Enable : integer := 0;
            AhbSlot14Enable : integer := 0;
            AhbSlot15Enable : integer := 1;
            AhbSlot1Enable : integer := 1;
            AhbSlot2Enable : integer := 0;
            AhbSlot3Enable : integer := 0;
            AhbSlot4Enable : integer := 0;
            AhbSlot5Enable : integer := 0;
            AhbSlot6Enable : integer := 0;
            AhbSlot7Enable : integer := 0;
            AhbSlot8Enable : integer := 0;
            AhbSlot9Enable : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            HADDR : in std_logic_vector(31 downto 0);
            HBURST : in std_logic_vector(2 downto 0);
            HCLK : in std_logic;
            HPROT : in std_logic_vector(3 downto 0);
            HRDATAS0 : in std_logic_vector(31 downto 0);
            HRDATAS1 : in std_logic_vector(31 downto 0);
            HRDATAS10 : in std_logic_vector(31 downto 0);
            HRDATAS11 : in std_logic_vector(31 downto 0);
            HRDATAS12 : in std_logic_vector(31 downto 0);
            HRDATAS13 : in std_logic_vector(31 downto 0);
            HRDATAS14 : in std_logic_vector(31 downto 0);
            HRDATAS15 : in std_logic_vector(31 downto 0);
            HRDATAS2 : in std_logic_vector(31 downto 0);
            HRDATAS3 : in std_logic_vector(31 downto 0);
            HRDATAS4 : in std_logic_vector(31 downto 0);
            HRDATAS5 : in std_logic_vector(31 downto 0);
            HRDATAS6 : in std_logic_vector(31 downto 0);
            HRDATAS7 : in std_logic_vector(31 downto 0);
            HRDATAS8 : in std_logic_vector(31 downto 0);
            HRDATAS9 : in std_logic_vector(31 downto 0);
            HREADYS0 : in std_logic;
            HREADYS1 : in std_logic;
            HREADYS10 : in std_logic;
            HREADYS11 : in std_logic;
            HREADYS12 : in std_logic;
            HREADYS13 : in std_logic;
            HREADYS14 : in std_logic;
            HREADYS15 : in std_logic;
            HREADYS2 : in std_logic;
            HREADYS3 : in std_logic;
            HREADYS4 : in std_logic;
            HREADYS5 : in std_logic;
            HREADYS6 : in std_logic;
            HREADYS7 : in std_logic;
            HREADYS8 : in std_logic;
            HREADYS9 : in std_logic;
            HRESETn : in std_logic;
            HRESPS0 : in std_logic_vector(1 downto 0);
            HRESPS1 : in std_logic_vector(1 downto 0);
            HRESPS10 : in std_logic_vector(1 downto 0);
            HRESPS11 : in std_logic_vector(1 downto 0);
            HRESPS12 : in std_logic_vector(1 downto 0);
            HRESPS13 : in std_logic_vector(1 downto 0);
            HRESPS14 : in std_logic_vector(1 downto 0);
            HRESPS15 : in std_logic_vector(1 downto 0);
            HRESPS2 : in std_logic_vector(1 downto 0);
            HRESPS3 : in std_logic_vector(1 downto 0);
            HRESPS4 : in std_logic_vector(1 downto 0);
            HRESPS5 : in std_logic_vector(1 downto 0);
            HRESPS6 : in std_logic_vector(1 downto 0);
            HRESPS7 : in std_logic_vector(1 downto 0);
            HRESPS8 : in std_logic_vector(1 downto 0);
            HRESPS9 : in std_logic_vector(1 downto 0);
            HSIZE : in std_logic_vector(2 downto 0);
            HTRANS : in std_logic_vector(1 downto 0);
            HWDATA : in std_logic_vector(31 downto 0);
            HWRITE : in std_logic;
            Remap : in std_logic;
            -- Outputs
            HADDRS : out std_logic_vector(31 downto 0);
            HBURSTS : out std_logic_vector(2 downto 0);
            HPROTS : out std_logic_vector(3 downto 0);
            HRDATA : out std_logic_vector(31 downto 0);
            HREADY : out std_logic;
            HREADYS : out std_logic;
            HRESP : out std_logic_vector(1 downto 0);
            HSELS0 : out std_logic;
            HSELS1 : out std_logic;
            HSELS10 : out std_logic;
            HSELS11 : out std_logic;
            HSELS12 : out std_logic;
            HSELS13 : out std_logic;
            HSELS14 : out std_logic;
            HSELS15 : out std_logic;
            HSELS2 : out std_logic;
            HSELS3 : out std_logic;
            HSELS4 : out std_logic;
            HSELS5 : out std_logic;
            HSELS6 : out std_logic;
            HSELS7 : out std_logic;
            HSELS8 : out std_logic;
            HSELS9 : out std_logic;
            HSIZES : out std_logic_vector(2 downto 0);
            HTRANSS : out std_logic_vector(1 downto 0);
            HWDATAS : out std_logic_vector(31 downto 0);
            HWRITES : out std_logic
        );
    end component;

    -- CoreAPB
    component CoreAPB
        -- Configuration generics
        generic(
            ApbSlot0Enable : integer := 1;
            ApbSlot10Enable : integer := 0;
            ApbSlot11Enable : integer := 0;
            ApbSlot12Enable : integer := 0;
            ApbSlot13Enable : integer := 0;
            ApbSlot14Enable : integer := 0;
            ApbSlot15Enable : integer := 0;
            ApbSlot1Enable : integer := 0;
            ApbSlot2Enable : integer := 0;
            ApbSlot3Enable : integer := 0;
            ApbSlot4Enable : integer := 0;
            ApbSlot5Enable : integer := 0;
            ApbSlot6Enable : integer := 0;
            ApbSlot7Enable : integer := 0;
            ApbSlot8Enable : integer := 0;
            ApbSlot9Enable : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            PADDR : in std_logic_vector(23 downto 0);
            PENABLE : in std_logic;
            PRDATAS0 : in std_logic_vector(31 downto 0);
            PRDATAS1 : in std_logic_vector(31 downto 0);
            PRDATAS10 : in std_logic_vector(31 downto 0);
            PRDATAS11 : in std_logic_vector(31 downto 0);
            PRDATAS12 : in std_logic_vector(31 downto 0);
            PRDATAS13 : in std_logic_vector(31 downto 0);
            PRDATAS14 : in std_logic_vector(31 downto 0);
            PRDATAS15 : in std_logic_vector(31 downto 0);
            PRDATAS2 : in std_logic_vector(31 downto 0);
            PRDATAS3 : in std_logic_vector(31 downto 0);
            PRDATAS4 : in std_logic_vector(31 downto 0);
            PRDATAS5 : in std_logic_vector(31 downto 0);
            PRDATAS6 : in std_logic_vector(31 downto 0);
            PRDATAS7 : in std_logic_vector(31 downto 0);
            PRDATAS8 : in std_logic_vector(31 downto 0);
            PRDATAS9 : in std_logic_vector(31 downto 0);
            PSELECT : in std_logic_vector(15 downto 0);
            PWDATA : in std_logic_vector(31 downto 0);
            PWRITE : in std_logic;
            -- Outputs
            PADDRS : out std_logic_vector(23 downto 0);
            PENABLES : out std_logic;
            PRDATA : out std_logic_vector(31 downto 0);
            PSELS0 : out std_logic;
            PSELS1 : out std_logic;
            PSELS10 : out std_logic;
            PSELS11 : out std_logic;
            PSELS12 : out std_logic;
            PSELS13 : out std_logic;
            PSELS14 : out std_logic;
            PSELS15 : out std_logic;
            PSELS2 : out std_logic;
            PSELS3 : out std_logic;
            PSELS4 : out std_logic;
            PSELS5 : out std_logic;
            PSELS6 : out std_logic;
            PSELS7 : out std_logic;
            PSELS8 : out std_logic;
            PSELS9 : out std_logic;
            PWDATAS : out std_logic_vector(31 downto 0);
            PWRITES : out std_logic
        );
    end component;

    -- CoreMP7Bridge
    component CoreMP7Bridge
        -- Configuration generics
        generic(
            DEBUG : integer := 2;
            SYNCFIQ : integer := 0;
            SYNCIRQ : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            ADDR : in std_logic_vector(31 downto 0);
            DBGTDO : in std_logic;
            DBGnTDOEN : in std_logic;
            HGRANT : in std_logic;
            HRDATA : in std_logic_vector(31 downto 0);
            HREADY : in std_logic;
            HRESP : in std_logic_vector(1 downto 0);
            LOCK : in std_logic;
            NSYSRESET : in std_logic;
            PROT : in std_logic_vector(1 downto 0);
            RV_TCK : in std_logic;
            RV_TDI : in std_logic;
            RV_TMS : in std_logic;
            RV_nSRST_IN : in std_logic;
            RV_nTRST : in std_logic;
            SIZE : in std_logic_vector(1 downto 0);
            SYSCLK : in std_logic;
            TRANS : in std_logic_vector(1 downto 0);
            UJTAG_TCK : in std_logic;
            UJTAG_TDI : in std_logic;
            UJTAG_TMS : in std_logic;
            UJTAG_TRSTB : in std_logic;
            WDATA : in std_logic_vector(31 downto 0);
            WDOGRES : in std_logic;
            WRITE : in std_logic;
            nFIQ_in : in std_logic;
            nIRQ_in : in std_logic;
            -- Outputs
            ABORT : out std_logic;
            CLK : out std_logic;
            CLKEN : out std_logic;
            DBGTCKEN : out std_logic;
            DBGTDI : out std_logic;
            DBGTMS : out std_logic;
            DBGnTRST : out std_logic;
            HADDR : out std_logic_vector(31 downto 0);
            HBURST : out std_logic_vector(2 downto 0);
            HBUSREQ : out std_logic;
            HLOCK : out std_logic;
            HPROT : out std_logic_vector(3 downto 0);
            HRESETn : out std_logic;
            HSIZE : out std_logic_vector(2 downto 0);
            HTRANS : out std_logic_vector(1 downto 0);
            HWDATA : out std_logic_vector(31 downto 0);
            HWRITE : out std_logic;
            RDATA : out std_logic_vector(31 downto 0);
            RV_RTCK : out std_logic;
            RV_TDOUT : out std_logic;
            RV_nTDOEN : out std_logic;
            UJTAG_TDO : out std_logic;
            WDOGRESn : out std_logic;
            nFIQ : out std_logic;
            nIRQ : out std_logic;
            nRESET : out std_logic
        );
    end component;

    -- A7S
    component A7S
        -- Port list
        port(
            -- Inputs
            ABORT : in std_logic;
            CFGBIGEND : in std_logic;
            CLK : in std_logic;
            CLKEN : in std_logic;
            CPA : in std_logic;
            CPB : in std_logic;
            DBGBREAK : in std_logic;
            DBGEN : in std_logic;
            DBGEXT : in std_logic_vector(1 downto 0);
            DBGRQ : in std_logic;
            DBGTCKEN : in std_logic;
            DBGTDI : in std_logic;
            DBGTMS : in std_logic;
            DBGnTRST : in std_logic;
            RDATA : in std_logic_vector(31 downto 0);
            nFIQ : in std_logic;
            nIRQ : in std_logic;
            nRESET : in std_logic;
            -- Outputs
            ADDR : out std_logic_vector(31 downto 0);
            CPSEQ : out std_logic;
            CPTBIT : out std_logic;
            CPnI : out std_logic;
            CPnMREQ : out std_logic;
            CPnOPC : out std_logic;
            CPnTRANS : out std_logic;
            DBGACK : out std_logic;
            DBGCOMMRX : out std_logic;
            DBGCOMMTX : out std_logic;
            DBGINSTRVALID : out std_logic;
            DBGRNG : out std_logic_vector(1 downto 0);
            DBGTDO : out std_logic;
            DBGnEXEC : out std_logic;
            DBGnTDOEN : out std_logic;
            DMORE : out std_logic;
            LOCK : out std_logic;
            PROT : out std_logic_vector(1 downto 0);
            SIZE : out std_logic_vector(1 downto 0);
            TRANS : out std_logic_vector(1 downto 0);
            WDATA : out std_logic_vector(31 downto 0);
            WRITE : out std_logic
        );
    end component;

    -- CoreMemCtrl
    component CoreMemCtrl
        -- Configuration generics
        generic(
            FLASH_16BIT : integer := 0;
            NUM_WS_FLASH_READ : integer := 3;
            NUM_WS_FLASH_WRITE : integer := 3;
            NUM_WS_SRAM_READ : integer := 2;
            NUM_WS_SRAM_WRITE : integer := 2;
            SHARED_RW : integer := 0;
            SYNC_SRAM : integer := 0
        );
        -- Port list
        port(
            -- Inputs
            HADDR : in std_logic_vector(27 downto 0);
            HCLK : in std_logic;
            HREADYIN : in std_logic;
            HRESETn : in std_logic;
            HSELflash : in std_logic;
            HSELsram : in std_logic;
            HSIZE : in std_logic_vector(2 downto 0);
            HTRANS : in std_logic_vector(1 downto 0);
            HWDATA : in std_logic_vector(31 downto 0);
            HWRITE : in std_logic;
            -- Outputs
            FlashCSN : out std_logic;
            FlashOEnN : out std_logic;
            FlashWEnN : out std_logic;
            HRDATAflash : out std_logic_vector(31 downto 0);
            HRDATAsram : out std_logic_vector(31 downto 0);
            HREADYflash : out std_logic;
            HREADYsram : out std_logic;
            HRESPflash : out std_logic_vector(1 downto 0);
            HRESPsram : out std_logic_vector(1 downto 0);
            MemAddr : out std_logic_vector(27 downto 0);
            MemReadN : out std_logic;
            MemWriteN : out std_logic;
            SramByteN : out std_logic_vector(3 downto 0);
            SramCSN : out std_logic;
            SramClk : out std_logic;
            SramOEnN : out std_logic;
            SramWEnN : out std_logic;
            -- Inouts
            MemData : inout std_logic_vector(31 downto 0)
        );
    end component;

    --
    -- Signal declarations
    --

    signal AHBmaster_HADDR : std_logic_vector(31 downto 0);
    signal AHBmaster_HBURST : std_logic_vector(2 downto 0);
    signal AHBmaster_HPROT : std_logic_vector(3 downto 0);
    signal AHBmaster_HRDATA : std_logic_vector(31 downto 0);
    signal AHBmaster_HREADY : std_logic;
    signal AHBmaster_HRESP : std_logic_vector(1 downto 0);
    signal AHBmaster_HSIZE : std_logic_vector(2 downto 0);
    signal AHBmaster_HTRANS : std_logic_vector(1 downto 0);
    signal AHBmaster_HWDATA : std_logic_vector(31 downto 0);
    signal AHBmaster_HWRITE : std_logic;
    signal AHBmslave0_HRDATA : std_logic_vector(31 downto 0);
    signal AHBmslave0_HREADYOUT : std_logic;
    signal AHBmslave0_HRESP : std_logic_vector(1 downto 0);
    signal AHBmslave0_HSELx : std_logic;
    signal AHBmslave15_HRDATA : std_logic_vector(31 downto 0);
    signal AHBmslave15_HREADYOUT : std_logic;
    signal AHBmslave15_HRESP : std_logic_vector(1 downto 0);
    signal AHBmslave15_HSELx : std_logic;
    signal AHBmslave1_00_HRDATA : std_logic_vector(31 downto 0);
    signal AHBmslave1_00_HREADYOUT : std_logic;
    signal AHBmslave1_00_HRESP : std_logic_vector(1 downto 0);
    signal AHBmslave1_00_HSELx : std_logic;
    signal APBmaster_PADDR : std_logic_vector(23 downto 0);
    signal APBmaster_PENABLE : std_logic;
    signal APBmaster_PRDATA : std_logic_vector(31 downto 0);
    signal APBmaster_PSELECT : std_logic_vector(15 downto 0);
    signal APBmaster_PWDATA : std_logic_vector(31 downto 0);
    signal APBmaster_PWRITE : std_logic;
    signal CoreAHBLite_00_HADDRS : std_logic_vector(31 downto 0);
    signal CoreAHBLite_00_HREADYS : std_logic;
    signal CoreAHBLite_00_HSIZES : std_logic_vector(2 downto 0);
    signal CoreAHBLite_00_HTRANSS : std_logic_vector(1 downto 0);
    signal CoreAHBLite_00_HWDATAS : std_logic_vector(31 downto 0);
    signal CoreAHBLite_00_HWRITES : std_logic;
    signal MP7_SysIf_ABORT : std_logic;
    signal MP7_SysIf_ADDR : std_logic_vector(31 downto 0);
    signal MP7_SysIf_CLK : std_logic;
    signal MP7_SysIf_CLKEN : std_logic;
    signal MP7_SysIf_DBGTCKEN : std_logic;
    signal MP7_SysIf_DBGTDI : std_logic;
    signal MP7_SysIf_DBGTDO : std_logic;
    signal MP7_SysIf_DBGTMS : std_logic;
    signal MP7_SysIf_DBGnTDOEN : std_logic;
    signal MP7_SysIf_DBGnTRST : std_logic;
    signal MP7_SysIf_LOCK : std_logic;
    signal MP7_SysIf_PROT : std_logic_vector(1 downto 0);
    signal MP7_SysIf_RDATA : std_logic_vector(31 downto 0);
    signal MP7_SysIf_SIZE : std_logic_vector(1 downto 0);
    signal MP7_SysIf_TRANS : std_logic_vector(1 downto 0);
    signal MP7_SysIf_WDATA : std_logic_vector(31 downto 0);
    signal MP7_SysIf_WRITE : std_logic;
    signal MP7_SysIf_nFIQ : std_logic;
    signal MP7_SysIf_nIRQ : std_logic;
    signal MP7_SysIf_nRESET : std_logic;

    signal iHRESETN : std_logic;

begin

    --
    -- Signal assignments
    --

    HRESETN <= iHRESETN;

    --
    -- Component instances
    --

    -- CoreAHB2APB_00
    CoreAHB2APB_00 : CoreAHB2APB
        -- Port map
        port map(
            -- Inputs
            HADDR => CoreAHBLite_00_HADDRS(27 downto 0),
            HCLK => SYSCLK,
            HREADY => CoreAHBLite_00_HREADYS,
            HRESETn => iHRESETN,
            HSEL => AHBmslave15_HSELx,
            HTRANS => CoreAHBLite_00_HTRANSS,
            HWDATA => CoreAHBLite_00_HWDATAS,
            HWRITE => CoreAHBLite_00_HWRITES,
            PRDATA => APBmaster_PRDATA,
            -- Outputs
            HRDATA => AHBmslave15_HRDATA,
            HREADYOUT => AHBmslave15_HREADYOUT,
            HRESP => AHBmslave15_HRESP,
            PADDR => APBmaster_PADDR,
            PENABLE => APBmaster_PENABLE,
            PSELECT => APBmaster_PSELECT,
            PWDATA => APBmaster_PWDATA,
            PWRITE => APBmaster_PWRITE
        );

    -- CoreAHBLite_00
    CoreAHBLite_00 : CoreAHBLite
        -- Configuration generics
        generic map(
            AhbSlot0Enable => 1,
            AhbSlot10Enable => 0,
            AhbSlot11Enable => 0,
            AhbSlot12Enable => 0,
            AhbSlot13Enable => 0,
            AhbSlot14Enable => 0,
            AhbSlot15Enable => 1,
            AhbSlot1Enable => 1,
            AhbSlot2Enable => 0,
            AhbSlot3Enable => 0,
            AhbSlot4Enable => 0,
            AhbSlot5Enable => 0,
            AhbSlot6Enable => 0,
            AhbSlot7Enable => 0,
            AhbSlot8Enable => 0,
            AhbSlot9Enable => 0
        )
        -- Port map
        port map(
            -- Inputs
            HADDR => AHBmaster_HADDR,
            HBURST => AHBmaster_HBURST,
            HCLK => SYSCLK,
            HPROT => AHBmaster_HPROT,
            HRDATAS0 => AHBmslave0_HRDATA,
            HRDATAS1 => AHBmslave1_00_HRDATA,
            HRDATAS10 => (others => '0'),
            HRDATAS11 => (others => '0'),
            HRDATAS12 => (others => '0'),
            HRDATAS13 => (others => '0'),
            HRDATAS14 => (others => '0'),
            HRDATAS15 => AHBmslave15_HRDATA,
            HRDATAS2 => (others => '0'),
            HRDATAS3 => (others => '0'),
            HRDATAS4 => (others => '0'),
            HRDATAS5 => (others => '0'),
            HRDATAS6 => (others => '0'),
            HRDATAS7 => (others => '0'),
            HRDATAS8 => (others => '0'),
            HRDATAS9 => (others => '0'),
            HREADYS0 => AHBmslave0_HREADYOUT,
            HREADYS1 => AHBmslave1_00_HREADYOUT,
            HREADYS10 => '1',
            HREADYS11 => '1',
            HREADYS12 => '1',
            HREADYS13 => '1',
            HREADYS14 => '1',
            HREADYS15 => AHBmslave15_HREADYOUT,
            HREADYS2 => '1',
            HREADYS3 => '1',
            HREADYS4 => '1',
            HREADYS5 => '1',
            HREADYS6 => '1',
            HREADYS7 => '1',
            HREADYS8 => '1',
            HREADYS9 => '1',
            HRESETn => iHRESETN,
            HRESPS0 => AHBmslave0_HRESP,
            HRESPS1 => AHBmslave1_00_HRESP,
            HRESPS10 => (others => '0'),
            HRESPS11 => (others => '0'),
            HRESPS12 => (others => '0'),
            HRESPS13 => (others => '0'),
            HRESPS14 => (others => '0'),
            HRESPS15 => AHBmslave15_HRESP,
            HRESPS2 => (others => '0'),
            HRESPS3 => (others => '0'),
            HRESPS4 => (others => '0'),
            HRESPS5 => (others => '0'),
            HRESPS6 => (others => '0'),
            HRESPS7 => (others => '0'),
            HRESPS8 => (others => '0'),
            HRESPS9 => (others => '0'),
            HSIZE => AHBmaster_HSIZE,
            HTRANS => AHBmaster_HTRANS,
            HWDATA => AHBmaster_HWDATA,
            HWRITE => AHBmaster_HWRITE,
            Remap => Remap,
            -- Outputs
            HADDRS => CoreAHBLite_00_HADDRS,
            HBURSTS => open,
            HPROTS => open,
            HRDATA => AHBmaster_HRDATA,
            HREADY => AHBmaster_HREADY,
            HREADYS => CoreAHBLite_00_HREADYS,
            HRESP => AHBmaster_HRESP,
            HSELS0 => AHBmslave0_HSELx,
            HSELS1 => AHBmslave1_00_HSELx,
            HSELS10 => open,
            HSELS11 => open,
            HSELS12 => open,
            HSELS13 => open,
            HSELS14 => open,
            HSELS15 => AHBmslave15_HSELx,
            HSELS2 => open,
            HSELS3 => open,
            HSELS4 => open,
            HSELS5 => open,
            HSELS6 => open,
            HSELS7 => open,
            HSELS8 => open,
            HSELS9 => open,
            HSIZES => CoreAHBLite_00_HSIZES,
            HTRANSS => CoreAHBLite_00_HTRANSS,
            HWDATAS => CoreAHBLite_00_HWDATAS,
            HWRITES => CoreAHBLite_00_HWRITES
        );

    -- CoreAPB_00
    CoreAPB_00 : CoreAPB
        -- Configuration generics
        generic map(
            ApbSlot0Enable => 1,
            ApbSlot10Enable => 0,
            ApbSlot11Enable => 0,
            ApbSlot12Enable => 0,
            ApbSlot13Enable => 0,
            ApbSlot14Enable => 0,
            ApbSlot15Enable => 0,
            ApbSlot1Enable => 0,
            ApbSlot2Enable => 0,
            ApbSlot3Enable => 0,
            ApbSlot4Enable => 0,
            ApbSlot5Enable => 0,
            ApbSlot6Enable => 0,
            ApbSlot7Enable => 0,
            ApbSlot8Enable => 0,
            ApbSlot9Enable => 0
        )
        -- Port map
        port map(
            -- Inputs
            PADDR => APBmaster_PADDR,
            PENABLE => APBmaster_PENABLE,
            PRDATAS0 => APBmslave0_PRDATA,
            PRDATAS1 => (others => '0'),
            PRDATAS10 => (others => '0'),
            PRDATAS11 => (others => '0'),
            PRDATAS12 => (others => '0'),
            PRDATAS13 => (others => '0'),
            PRDATAS14 => (others => '0'),
            PRDATAS15 => (others => '0'),
            PRDATAS2 => (others => '0'),
            PRDATAS3 => (others => '0'),
            PRDATAS4 => (others => '0'),
            PRDATAS5 => (others => '0'),
            PRDATAS6 => (others => '0'),
            PRDATAS7 => (others => '0'),
            PRDATAS8 => (others => '0'),
            PRDATAS9 => (others => '0'),
            PSELECT => APBmaster_PSELECT,
            PWDATA => APBmaster_PWDATA,
            PWRITE => APBmaster_PWRITE,
            -- Outputs
            PADDRS => APBmslave0_PADDR,
            PENABLES => APBmslave0_PENABLE,
            PRDATA => APBmaster_PRDATA,
            PSELS0 => APBmslave0_PSELx,
            PSELS1 => open,
            PSELS10 => open,
            PSELS11 => open,
            PSELS12 => open,
            PSELS13 => open,
            PSELS14 => open,
            PSELS15 => open,
            PSELS2 => open,
            PSELS3 => open,
            PSELS4 => open,
            PSELS5 => open,
            PSELS6 => open,
            PSELS7 => open,
            PSELS8 => open,
            PSELS9 => open,
            PWDATAS => APBmslave0_PWDATA,
            PWRITES => APBmslave0_PWRITE
        );

    -- CoreMP7Bridge_00
    CoreMP7Bridge_00 : CoreMP7Bridge
        -- Configuration generics
        generic map(
            DEBUG => 2,
            SYNCFIQ => 0,
            SYNCIRQ => 0
        )
        -- Port map
        port map(
            -- Inputs
            ADDR => MP7_SysIf_ADDR,
            DBGTDO => MP7_SysIf_DBGTDO,
            DBGnTDOEN => MP7_SysIf_DBGnTDOEN,
            HGRANT => '1',
            HRDATA => AHBmaster_HRDATA,
            HREADY => AHBmaster_HREADY,
            HRESP => AHBmaster_HRESP,
            LOCK => MP7_SysIf_LOCK,
            NSYSRESET => NSYSRESET,
            PROT => MP7_SysIf_PROT,
            RV_TCK => RV_ICE_If_RV_TCK,
            RV_TDI => RV_ICE_If_RV_TDI,
            RV_TMS => RV_ICE_If_RV_TMS,
            RV_nSRST_IN => RV_ICE_If_RV_nSRST_IN,
            RV_nTRST => RV_ICE_If_RV_nTRST,
            SIZE => MP7_SysIf_SIZE,
            SYSCLK => SYSCLK,
            TRANS => MP7_SysIf_TRANS,
            UJTAG_TCK => UJTAG_UJTAG_TCK,
            UJTAG_TDI => UJTAG_UJTAG_TDI,
            UJTAG_TMS => UJTAG_UJTAG_TMS,
            UJTAG_TRSTB => UJTAG_UJTAG_TRSTB,
            WDATA => MP7_SysIf_WDATA,
            WDOGRES => '0',
            WRITE => MP7_SysIf_WRITE,
            nFIQ_in => '1',
            nIRQ_in => '1',
            -- Outputs
            ABORT => MP7_SysIf_ABORT,
            CLK => MP7_SysIf_CLK,
            CLKEN => MP7_SysIf_CLKEN,
            DBGTCKEN => MP7_SysIf_DBGTCKEN,
            DBGTDI => MP7_SysIf_DBGTDI,
            DBGTMS => MP7_SysIf_DBGTMS,
            DBGnTRST => MP7_SysIf_DBGnTRST,
            HADDR => AHBmaster_HADDR,
            HBURST => AHBmaster_HBURST,
            HBUSREQ => open,
            HLOCK => open,
            HPROT => AHBmaster_HPROT,
            HRESETn => iHRESETN,
            HSIZE => AHBmaster_HSIZE,
            HTRANS => AHBmaster_HTRANS,
            HWDATA => AHBmaster_HWDATA,
            HWRITE => AHBmaster_HWRITE,
            RDATA => MP7_SysIf_RDATA,
            RV_RTCK => RV_ICE_If_RV_RTCK,
            RV_TDOUT => RV_ICE_If_RV_TDOUT,
            RV_nTDOEN => RV_ICE_If_RV_nTDOEN,
            UJTAG_TDO => UJTAG_UJTAG_TDO,
            WDOGRESn => open,
            nFIQ => MP7_SysIf_nFIQ,
            nIRQ => MP7_SysIf_nIRQ,
            nRESET => MP7_SysIf_nRESET
        );

    -- CoreMP7_00
    CoreMP7_00 : A7S
        -- Port map
        port map(
            -- Inputs
            ABORT => MP7_SysIf_ABORT,
            CFGBIGEND => '0',
            CLK => MP7_SysIf_CLK,
            CLKEN => MP7_SysIf_CLKEN,
            CPA => '1',
            CPB => '1',
            DBGBREAK => '0',
            DBGEN => '1',
            DBGEXT => (others => '0'),
            DBGRQ => '0',
            DBGTCKEN => MP7_SysIf_DBGTCKEN,
            DBGTDI => MP7_SysIf_DBGTDI,
            DBGTMS => MP7_SysIf_DBGTMS,
            DBGnTRST => MP7_SysIf_DBGnTRST,
            RDATA => MP7_SysIf_RDATA,
            nFIQ => MP7_SysIf_nFIQ,
            nIRQ => MP7_SysIf_nIRQ,
            nRESET => MP7_SysIf_nRESET,
            -- Outputs
            ADDR => MP7_SysIf_ADDR,
            CPSEQ => open,
            CPTBIT => open,
            CPnI => open,
            CPnMREQ => open,
            CPnOPC => open,
            CPnTRANS => open,
            DBGACK => open,
            DBGCOMMRX => open,
            DBGCOMMTX => open,
            DBGINSTRVALID => open,
            DBGRNG => open,
            DBGTDO => MP7_SysIf_DBGTDO,
            DBGnEXEC => open,
            DBGnTDOEN => MP7_SysIf_DBGnTDOEN,
            DMORE => open,
            LOCK => MP7_SysIf_LOCK,
            PROT => MP7_SysIf_PROT,
            SIZE => MP7_SysIf_SIZE,
            TRANS => MP7_SysIf_TRANS,
            WDATA => MP7_SysIf_WDATA,
            WRITE => MP7_SysIf_WRITE
        );

    -- CoreMemCtrl_00
    CoreMemCtrl_00 : CoreMemCtrl
        -- Configuration generics
        generic map(
            FLASH_16BIT => 0,
            NUM_WS_FLASH_READ => 3,
            NUM_WS_FLASH_WRITE => 3,
            NUM_WS_SRAM_READ => 2,
            NUM_WS_SRAM_WRITE => 2,
            SHARED_RW => 0,
            SYNC_SRAM => 0
        )
        -- Port map
        port map(
            -- Inputs
            HADDR => CoreAHBLite_00_HADDRS(27 downto 0),
            HCLK => SYSCLK,
            HREADYIN => CoreAHBLite_00_HREADYS,
            HRESETn => iHRESETN,
            HSELflash => AHBmslave0_HSELx,
            HSELsram => AHBmslave1_00_HSELx,
            HSIZE => CoreAHBLite_00_HSIZES,
            HTRANS => CoreAHBLite_00_HTRANSS,
            HWDATA => CoreAHBLite_00_HWDATAS,
            HWRITE => CoreAHBLite_00_HWRITES,
            -- Outputs
            FlashCSN => ExternalMemoryInterface_FlashCSN,
            FlashOEnN => ExternalMemoryInterface_FlashOEnN,
            FlashWEnN => ExternalMemoryInterface_FlashWEnN,
            HRDATAflash => AHBmslave0_HRDATA,
            HRDATAsram => AHBmslave1_00_HRDATA,
            HREADYflash => AHBmslave0_HREADYOUT,
            HREADYsram => AHBmslave1_00_HREADYOUT,
            HRESPflash => AHBmslave0_HRESP,
            HRESPsram => AHBmslave1_00_HRESP,
            MemAddr => ExternalMemoryInterface_MemAddr,
            MemReadN => ExternalMemoryInterface_MemReadN,
            MemWriteN => ExternalMemoryInterface_MemWriteN,
            SramByteN => ExternalMemoryInterface_SramByteN,
            SramCSN => ExternalMemoryInterface_SramCSN,
            SramClk => ExternalMemoryInterface_SramClk,
            SramOEnN => ExternalMemoryInterface_SramOEnN,
            SramWEnN => ExternalMemoryInterface_SramWEnN,
            -- Inouts
            MemData => ExternalMemoryInterface_MemData
        );

end RTL;

