//////////////////////////////////////////////////////////////////////
// Created by Actel CoreConsole - Thu Jan 04 10:38:02 2007
//////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

module testbench;

parameter SYSCLK_PERIOD = 100; // 10MHz

reg SYSCLK;
reg NSYSRESET;

initial
begin
    SYSCLK = 1'b0;
    NSYSRESET = 1'b0;

    // Release system reset
    #(SYSCLK_PERIOD * 4)
        NSYSRESET = 1'b1;

    #(SYSCLK_PERIOD * 100000);

    $stop;
end

// SYSCLK signal
always @(SYSCLK)
    #(SYSCLK_PERIOD / 2)
    SYSCLK <= !SYSCLK;

// Instantiate module to test
Example Example_0(
    // Inputs
    .APBmslave0_PRDATA({32{1'b0}}),
    .NSYSRESET(NSYSRESET),
    .RV_ICE_If_RV_TCK({1{1'b0}}),
    .RV_ICE_If_RV_TDI({1{1'b0}}),
    .RV_ICE_If_RV_TMS({1{1'b1}}),
    .RV_ICE_If_RV_nSRST_IN({1{1'b1}}),
    .RV_ICE_If_RV_nTRST({1{1'b1}}),
    .Remap({1{1'b0}}),
    .SYSCLK(SYSCLK),
    .UJTAG_UJTAG_TCK({1{1'b0}}),
    .UJTAG_UJTAG_TDI({1{1'b0}}),
    .UJTAG_UJTAG_TMS({1{1'b0}}),
    .UJTAG_UJTAG_TRSTB({1{1'b0}}),
    // Outputs
    .APBmslave0_PADDR(),
    .APBmslave0_PENABLE(),
    .APBmslave0_PSELx(),
    .APBmslave0_PWDATA(),
    .APBmslave0_PWRITE(),
    .ExternalMemoryInterface_FlashCSN(),
    .ExternalMemoryInterface_FlashOEnN(),
    .ExternalMemoryInterface_FlashWEnN(),
    .ExternalMemoryInterface_MemAddr(),
    .ExternalMemoryInterface_MemReadN(),
    .ExternalMemoryInterface_MemWriteN(),
    .ExternalMemoryInterface_SramByteN(),
    .ExternalMemoryInterface_SramCSN(),
    .ExternalMemoryInterface_SramClk(),
    .ExternalMemoryInterface_SramOEnN(),
    .ExternalMemoryInterface_SramWEnN(),
    .HRESETN(),
    .RV_ICE_If_RV_RTCK(),
    .RV_ICE_If_RV_TDOUT(),
    .RV_ICE_If_RV_nTDOEN(),
    .UJTAG_UJTAG_TDO(),
    // Inouts
    .ExternalMemoryInterface_MemData()
);

endmodule

